from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, String

Pairalign_V0_1_0 = CommandToolBuilder(tool="pairalign", base_command=["pairalign"], inputs=[ToolInput(tag="in_aligned", input_type=Boolean(optional=True), prefix="--aligned", doc=InputDocumentation(doc="input file is already aligned.")), ToolInput(tag="in_alignments", input_type=Boolean(optional=True), prefix="--alignments", doc=InputDocumentation(doc="output aligned sequences pairwise.")), ToolInput(tag="in_difference", input_type=Boolean(optional=True), prefix="--difference", doc=InputDocumentation(doc="output difference between the Jukes-Cantor (JC)\ndistance and proportion different sites.")), ToolInput(tag="in_distances", input_type=Boolean(optional=True), prefix="--distances", doc=InputDocumentation(doc="output proportion different sites, JC distance,\nand diference between the two.")), ToolInput(tag="in_format", input_type=Boolean(optional=True), prefix="--format", doc=InputDocumentation(doc="[fasta/pairfst]        set the format of the input to fasta or fasta\nwith sequences pairwise (as output given the -a\n-n option). If sequences are aligned give the -A\nswitch.")), ToolInput(tag="in_group", input_type=Boolean(optional=True), prefix="--group", doc=InputDocumentation(doc="this option will cluster sequences that are\nsimilar and/or find the most inclusive taxa in a\nhierarchy that are alignable according to MAD\n(Smith et al. 2009, BMC evol. Biol. 9:37). It\nneed the taxonomy given after a (the first) | in\nthe sequence name or in a separate file. Each\ntaxa in the hierarchy should be separated by a\nsemicolon, with the highest rank first and then\nincreasingly nested levels until the lowest\nknown level for the sequence. The groups that\ncan be aligned are put in a file with the ending\n.alignment_groups and printed to the screen\npreceded by #. Clusters are printed to the\nscreen after a heading, preceded by ###. To get\nalignable groups give 'alignment_groups' as\nextra argument, to cluster give 'cluster', and\nto do both give 'both'. Cut off value for\npairwise similarity can be given after colon (:)\nby cut-off= followed value, e.g. -g both:\ncut-off=0.97. A file with taxonomy can be given\nwith taxonomy=. The taxonomy file should have\nthe taxonomy (as above) first on each row\nfollowed by a |, and the sequence name with that\ntaxonomy as a comma (,) and/or space ( )\nseparated string. The same taxon can be repeated\nseveral times.")), ToolInput(tag="in_jc_distance", input_type=Boolean(optional=True), prefix="--jc_distance", doc=InputDocumentation(doc="output Jukes-Cantor (JC) distance.")), ToolInput(tag="in_matrix", input_type=Boolean(optional=True), prefix="--matrix", doc=InputDocumentation(doc="output in the form of a space separated\nleft-upper triangular matrix.")), ToolInput(tag="in_names", input_type=Boolean(optional=True), prefix="--names", doc=InputDocumentation(doc="output sequence names (if outputting alignments\nthen in fasta format).")), ToolInput(tag="in_proportion_difference", input_type=Boolean(optional=True), prefix="--proportion_difference", doc=InputDocumentation(doc="output proportion sites that are different.")), ToolInput(tag="in_similarity", input_type=Boolean(optional=True), prefix="--similarity", doc=InputDocumentation(doc="output similarity between sequences (1-proportion\ndifferent).")), ToolInput(tag="in_threads", input_type=Boolean(optional=True), prefix="--threads", doc=InputDocumentation(doc="[number]         set the number of threads additional to the\ncontrolling thread, e.g. -T 4. The order of\noutput between pairs are not guaranteed for more\nthan one thread (default 1).")), ToolInput(tag="in_verbose", input_type=Boolean(optional=True), prefix="--verbose", doc=InputDocumentation(doc="get additional output.")), ToolInput(tag="in_arguments", input_type=String(optional=True), position=0, doc=InputDocumentation(doc=""))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Pairalign_V0_1_0().translate("wdl", allow_empty_container=True)

